# (nowrap)
set menuFlags(defaultFont)		"system monaco courier geneva helvetica times {new york}"
set menuFlags(printerFont)		"system monaco courier geneva helvetica times {new york}"
set menuFlags(printerFontSize)	"9 10 12 14 18"
set menuFlags(fontSize)			"9 10 12 14 18"
set menuFlags(savedState)		"none think mpw"

			
proc modeDialog {flags vars} {
	global menuFlags
	
	set left 20
	set top 10
	set t $top
	
	set perRow	3
	set width	150
	set height	15

	set ind 0 

	foreach f $flags {
		global $f
		set l [expr $left + ($ind % $perRow) * $width]
		set t [expr $top + ($ind / $perRow) * $height]
		lappend args "-c" $f [set $f] $l $t [expr $l + $width] [expr $t + $height]
		incr ind
	}
	
	if {$ind} {
		set top [expr $t + 40]
		set divider "-p 100 [expr $t + 27] 300 [expr $t + 28]"
	} else {
		set divider ""
		
	}
	
	set perRow	1
	set width	400
	set height	15
	
	set inc [expr $height + 10]
	
	set ind 0
	foreach v $vars {
		global $v
		set l [expr $left + ($ind % $perRow) * $width]
		set t [expr $top + ($ind / $perRow) * $inc]
		lappend args "-t" "$v:" $l $t [expr $l + 125] [expr $t + $height]

		if {[string match "*Color" $v]} {
			lappend args "-m" [concat [list [set $v]] {none blue cyan green magenta red white yellow}] [expr $l + 123] $t [expr $l + $width - 14] [expr $t + $height +1]
		} elseif {[info exists menuFlags($v)]} {
			lappend args "-m" [concat [list [set $v]] $menuFlags($v)] [expr $l + 123] $t [expr $l + $width - 14] [expr $t + $height +1]
		} else {
			lappend args "-e" [set $v] [expr $l + 125] $t [expr $l + $width - 10] [expr $t + $height +1]
		}
		incr ind
	}
	
	set height [expr $t + 60]
	set res [eval dialog -w 480 -h $height -b OK $left [expr $height-30] [expr $left + 60] [expr $height-10] $divider -b Cancel [expr $left + 100] [expr $height-30] [expr $left + 160] [expr $height-10] $args] 
	if {[lindex $res 0]} {
		return [lrange $res 2 end]
	} else {
		error "Cancel chosen"
	}
}



proc dialSet {flags vars} {
	global maxT menuFlags
	
	set left 20
	set top 40
	set t $top
	
	set perRow	3
	set width	150
	set height	15

	set ind 0 

	set args {}
	
	foreach f $flags {
		global $f
		set l [expr $left + ($ind % $perRow) * $width]
		set t [expr $top + ($ind / $perRow) * $height]
		lappend args "-c" $f [set $f] $l $t [expr $l + $width] [expr $t + $height]
		incr ind
	}
	
	if {$ind} {
		set top [expr $t + 40]
		lappend args -p 100 [expr $t + 27] 300 [expr $t + 28]
	}
	
	set perRow	1
	set width	400
	set height	17
	
	set inc [expr $height + 10]
	
	set ind 0 
	foreach v $vars {
		global $v
		set l [expr $left + ($ind % $perRow) * $width]
		set t [expr $top + ($ind / $perRow) * $inc]
		lappend args "-t" "$v:" $l $t [expr $l + 125] [expr $t + $height]

		if {[string match "*Color" $v]} {
			lappend args "-m" [concat [list [set $v]] {none blue cyan green magenta red white yellow}] [expr $l + 123] $t [expr $l + $width - 14] [expr $t + $height +1]
		} elseif {[info exists menuFlags($v)]} {
			lappend args "-m" [concat [list [set $v]] $menuFlags($v)] [expr $l + 123] $t [expr $l + $width - 14] [expr $t + $height +1]
		} else {
			lappend args "-e" [set $v] [expr $l + 125] $t [expr $l + $width - 12] [expr $t + $height +1]
		}
		incr ind
	}

	incr t 30
	if {$t > $maxT} {set maxT $t}
	return $args
}
