
#===============================================================================
lappend modes C
set dummyProc(C)				dummyC
lappend modeSuffixes	 		{*.h} { set winMode C }
lappend modeSuffixes			{*.c} { set winMode C }
lappend modeSuffixes			{*.r} { set winMode C }
set modeMenus(C) 				{ thinkMenu cwarriorMenu thinkRefMenu toolboxRefMenu}

#================================================================================
lappend modes C++
set dummyProc(C++)				dummyC++
lappend modeSuffixes		 	{*.H} { set winMode C++ }
lappend modeSuffixes			{*.cc} { set winMode C++ }
lappend modeSuffixes			{*.cp} { set winMode C++ }
lappend modeSuffixes			{*.cpp} { set winMode C++ }
lappend modeSuffixes			{*.CPP} { set winMode C++ }
lappend modeSuffixes			{*.C} { set winMode C++ }
set modeMenus(C++) 				{ thinkMenu cwarriorMenu thinkRefMenu toolboxRefMenu}

#===============================================================================
# PL/SQL mode by Joel D. Elkins
lappend modes SQL
set modeMenus(SQL)						{ }
set dummyProc(SQL)						dummySQL
lappend modeSuffixes					{*.sql} { set winMode SQL }
lappend modeSuffixes					{*.SQL} { set winMode SQL }
lappend modeSuffixes					{*.pkg}	{ set winMode SQL }

#================================================================================
lappend modes Shel
set dummyProc(Shel)				dummyShel
set modeMenus(Shel) 			{ tclMenu }
lappend modeSuffixes			{*tcl\ sh*} {set winMode Shel}
newModeVar Shel wordBreak {(\$)?[a-zA-Z0-9_.]+} 0
newModeVar Shel wordWrap {0} 1
newModeVar Shel wordBreakPreface {[^a-zA-Z0-9_\$]} 0
newModeVar Shel autoMark	0	1
regModeKeywords -m {} Shel {}

#===============================================================================
#	AppleScript mode
lappend modes Scrp
set dummyProc(Scrp)				dummyScrp
lappend modeSuffixes	 		{*.script} { set winMode Scrp }
set modeMenus(Scrp) 			{ }


#================================================================================
lappend modes PS
lappend modeSuffixes			{*.ps} { set winMode PS }
newModeVar PS prefixString {% } 0 
set PSKeyWords {
	def begin end dict load
	exec if ifelse for repeat loop exit stop stopped countexecstack execstack quit start
	gsave grestore grestoreall initgraphics 
	newpath erasepage fill eofill stroke image imagemask showpage copypage
}
if {[info exists PSwords]} {set PSKeyWords [concat $PSKeyWords $PSwords]}
regModeKeywords -e {%} -m {/}  -c red -k blue PS $PSKeyWords -i "\}" -i "\{" -i {[} -i {]} -I green
unset PSKeyWords

#================================================================================
lappend modes Fort
lappend modeSuffixes			{*.f} { set winMode Fort }
lappend modeSuffixes			{*.inc} { set winMode Fort }
lappend modeSuffixes			{*.INC} { set winMode Fort }
lappend modeSuffixes			{*.fcm} { set winMode Fort }
lappend modeSuffixes			{*.for} { set winMode Fort }
lappend modeSuffixes			{*.FOR} { set winMode Fort }
lappend modeSuffixes 			{*.f9}	{ set winMode Fort }
lappend modeSuffixes			{*.f90}	{ set winMode Fort }
lappend modeSuffixes			{*.hpf}	{ set winMode Fort }
set dummyProc(Fort)				dummyFort
set modeMenus(Fort) 			{ }

#================================================================================
lappend modes Scm
set dummyProc(Scm)				dummyScm
set modeMenus(Scm) 				{ }
lappend modeSuffixes	 		{*.scm} { set winMode Scm }

#================================================================================
lappend modes Pasc
lappend modeSuffixes	 		{*.p} { set winMode Pasc }
set dummyProc(Pasc)				dummyPascal
set modeMenus(Pasc)				{ thinkRefMenu toolboxRefMenu}

#=============================================================================
lappend modes Tcl
set dummyProc(Tcl)				dummyTcl
lappend modeSuffixes			{*.tcl} { set winMode Tcl }
set modeMenus(Tcl) 				{ tclMenu }

#================================================================================
lappend modes MPW
set modeMenus(MPW) 				{ }
lappend modeSuffixes			{*Toolserver\ *} { set winMode MPW }

#================================================================================
lappend modes Brws
set modeMenus(Brws) 			{ }
set dummyProc(Brws)				dummyBrws
#===============================================================================
lappend modes Mail
set dummyProc(Mail)				dummyMail
set modeMenus(Mail) 			{  }
newModeVar Mail wordBreak {(\$)?[a-zA-Z0-9_.]+} 0
newModeVar Mail wordWrap {0} 1
newModeVar Mail wordBreakPreface {[^a-zA-Z0-9_\$]} 0
newModeVar Mail autoMark	0	1
set mailKeywords {{Subject:} {To:} {From:} {Cc:} {Sender:}}
regModeKeywords -k blue -e {>} Mail $mailKeywords
#================================================================================
lappend modes Diff
set modeMenus(Diff) 			{ }
#================================================================================
lappend modes Ada
set dummyProc(Ada)				dummyAda
set modeMenus(Ada) 				{ }
lappend modeSuffixes	 		{*.ada} { set winMode Ada }
lappend modeSuffixes			{*.ads} { set winMode Ada }
lappend modeSuffixes			{*.adb} { set winMode Ada }
lappend modeSuffixes			{*.ADS} { set winMode Ada }
lappend modeSuffixes			{*.ADB} { set winMode Ada }
lappend modeSuffixes			{*_.a} { set winMode Ada }
lappend modeSuffixes			{*.a} { set winMode Ada }
#===============================================================================
